VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_draw_rainbow"
   ClientHeight    =   1950
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   1950
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    Me.ScaleMode = vbPixels
End Sub

' Draw rainbow colors on the form.
Private Sub Form_Paint()
Dim wid As Integer
Dim hgt As Integer
Dim hgt2 As Integer
Dim x As Integer
Dim clr As OLE_COLOR

    wid = Me.ScaleWidth
    hgt = Me.ScaleHeight
    hgt2 = Int(hgt / 2)
    For x = 0 To wid - 1
        clr = MapRainbowColor(x, 0, wid)
        Me.Line (x, 0)-(x, hgt2), clr

        clr = MapRainbowColor(x, wid, 0)
        Me.Line (x, hgt2)-(x, hgt), clr
    Next x
End Sub

' Map a value to a rainbow color.
Private Function MapRainbowColor(ByVal value As Single, ByVal red_value As Single, ByVal blue_value As Single) As OLE_COLOR
Dim int_value As Integer
    
    ' Convert into a value between 0 and 1023.
    int_value = Int(1023 * (value - red_value) / (blue_value - red_value))

    ' Map different color bands.
    If (int_value < 256) Then
        ' Red to yellow. (255, 0, 0) to (255, 255, 0).
        MapRainbowColor = RGB(255, int_value, 0)
    ElseIf (int_value < 512) Then
        ' Yellow to green. (255, 255, 0) to (0, 255, 0).
        int_value = int_value - 256
        MapRainbowColor = RGB(255 - int_value, 255, 0)
    ElseIf (int_value < 768) Then
        ' Green to aqua. (0, 255, 0) to (0, 255, 255).
        int_value = int_value - 512
        MapRainbowColor = RGB(0, 255, int_value)
    Else
        ' Aqua to blue. (0, 255, 255) to (0, 0, 255).
        int_value = int_value - 768
        MapRainbowColor = RGB(0, 255 - int_value, 255)
    End If
End Function

